#!/usr/bin/perl
use strict;
use MP3::Info;
use File::Copy;
#  Copyright (C) 2002 Adrian Ulrich <pab at blinkenlights.ch>
#  Part of the gnupod-tools collection
#
#  URL: http://www.blinkenlights.ch/cgi-bin/fm.pl?get=ipod
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# iTunes and iPod are trademarks of Apple
#
# This product is not supported/written/published by Apple!

print "gnupod addsong 0.3 (C) 2002 Adrian Ulrich\n";
print "Part of the gnupod-tools collection\n";
print "This tool copies files to your iPod and updates the gnuPod file\n\n";

if(!$ARGV[1]) #we need 2 args (or more)
 { 
  print "Usage: gnupod_addsong.pl iPod_MOUNTPOINT FILENAME\n"; 
  exit(1);
 }
elsif(!(-d $ARGV[0]))
 {
  print "Error: iPod mountpoint\n $ARGV[0]\nis not a directory\n";
  print "Usage: gnupod_addsong.pl iPod_MOUNTPOINT FILENAME\n"; 
  exit(1);
 }


stdtest(); #test if INIT was done

print "This action would add ".(int(@ARGV)-1)." item(s) to your iPod wich is mounted at\n";
print " $ARGV[0]\n\n";
print "Hit ENTER to continue, CTRL+C to abort.\n";
<STDIN>;
go();



sub go
{
$|++;
my($file, $rnum, $entry, $out, $clp, $i, $sstring, $transfered);
($file) = @_;

print "-> Parsing old GNUtunesDB\n";
open(GPH, "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") or die "Could not open GNUtunesDB: $!\ndid you run 'gnupod_INITpod.pl' ?\n";
 while(defined($i = <GPH>)) #get old gnupod file
 {
  $out = $out.$i;
 }
close(GPH);
print "-> Searching space for new files and creating elements..\n"; 


for($i=1;$i!=int(@ARGV);$i++)
{
      if(-r $ARGV[$i] && !(-d $ARGV[$i]))
      {
         ($entry, $rnum) = mk_entry($ARGV[$i]); #search space and create the entry
	
         if($entry) #parser ok
	 {
	  $clp = cleanname($ARGV[$i]); #get cleanname (for copy())
	  
	  (undef, $sstring) = split(/\t/,$entry, 2);
	  #replace bad chars for search
	  $sstring =~ s/(\\|\^|\$|\||\(|\)|\[|\]|\*|\+|\?|\{|\}|\,)/\\\1/g;
	   if($out =~ m|$sstring|) #its a duplicate!
	    {
	     print "! File $ARGV[$i] exists on iPod, skipping\n";
	    }
	   else #not a dup
	   {
	       if(!copy("$ARGV[$i]", "$ARGV[0]/iPod_Control/Music/F$rnum/$clp")) #copy failed, bad
	       {
	         print "--  FATAL  -- Failed to copy $ARGV[0]\n $!\nfile not in playlist\n";
	       }
	       else #copy ok, add file to playlist
	       {
	         print "+ $ARGV[$i]\n";
	         $out = $out.$entry;
		 $transfered++;
	       }
	    } 
         }
         else #parser failed, but we could read the file.. maybe no mp3
         {
           print "**  ERROR  ** Not a mp3 or to many dups: skipped '$ARGV[$i]'\n";
         }
      
      }
      else #a dir or not readable, skip this file
      {
        print "- Skipped $ARGV[$i]\n";
      }
 
}

print "\n\n-> Updating gnuPod file on your iPod\n";
  open(GPH, "> $ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") or die "--  FATAL  -- Error writing GNUtunesDB: $!\n\
  Did you run 'gnupod_INITpod.pl' ?? - rgs.. you got zombie-mp3s on your iPod, good look :/\n";
    print GPH $out;
  close(GPH);
print "-> done, added ".int($transfered)." file(s)\n";

print "-> NOTE: run 'mktunes.pl' *BEFORE* unmounting your iPod!\n";

}





#creates a line in gnuPodfile format.. 
sub mk_entry
{
my($file, $inf, $info, $tag, $ret, $rand, $i, $clp);
($file) = @_;

$info = get_mp3info($file);
$tag  = get_mp3tag($file); 

return 0 if (!$info); #$tag can fail -> in this case, we simulate a tag
print "-- WARNING --  no id3tag found for file:\n $file\nPlacing as UNKNOWN ARTIST\n" if (!$tag); #..but we warn the user

#pathname
$clp = cleanname($file);



$i=0; #we use random numbers to seed the files (itunes does also something like that, .. i think)
for($rand=sprintf("%02d",int(rand(20)));(-e "$ARGV[0]/iPod_Control/Music/F$rand/$clp");$rand=sprintf("%02d",int(rand(20)))) #damd ugly :)
{
 $i++;
# print "-- WARNING -- File with same name exists in F$rand .. changing target ($i)\n";
  if($i > 40)
  {
   print "--  OUCH   -- No space found (looped $i times)\n"; #this shouldn't happen with dupchecking
   return 0;
  }
}


# if we are here, we should get name, bitrate, size and length without any problems
$ret = ":iPod_Control:Music:F$rand:$clp\t"; #ipod filename
$ret = $ret.$info->{BITRATE}."\t";          #bitrate
$ret = $ret.int(($info->{SECS}*1000))."\t"; #length
$ret = $ret.((stat($file))[7])."\t";        #filesize

#ID3tag checks
if($tag->{TITLE})
 { $ret = $ret.$tag->{TITLE}."\t"; }
else 
 { $ret = $ret."$clp\t"; } #set filename as name

if($tag->{ARTIST})
 { $ret = $ret.$tag->{ARTIST}."\t"; }
else
 { $ret = $ret."Unknown Artist\t"; }

if($tag->{ALBUM})
 { $ret = $ret.$tag->{ALBUM}."\n"; }
else
 { $ret = $ret."Unknown Album\n"; }


return $ret, $rand;
}


#create a name for the file for the ipod
# -> remove bad chars
# -> limit name to 32.3 chars
sub cleanname
{
my($path, @ta, $cname, $noext, $ext);
($path) = @_;
@ta = split(/\//, $path);
$cname = (@ta[int(@ta)-1]);
 $cname =~ tr/A-Za-z0-9./_/c;
 ($ext, $noext) = split(/\./, reverse($cname), 2);
 $noext = reverse($noext); $ext = reverse($ext);
 $noext = substr($noext, 0, 32);
 return "$noext\.$ext";
}



sub stdtest
{
if(!(-w "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB"))
{
 print "Error: Cant write to your gnuPod-file\ndid you run 'gnupod_INITpod.pl' ?\n";
 exit(1);
}
if(!(-w "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: Cant write to your iTunesDB\ndid you run 'gnupod_INITpod.pl' ?\n";
 exit(1);
}

if ((-M "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") > (-M "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: your gnuPod-file is older than your iTunesDB! (Last update not done with gnuPod?)\n";
 print "Please run this comment to correct this problem:\n";
 print "tunes2pod.pl \$IPOD_MOUNTPOINT/iPod_Control/iTunes/iTunesDB > \$IPOD_MOUNTPOINT/iPod_Control/.gnupod/GNUtunesDB\n\n";
 print "This command will update your current gnuPodfile with the contents of your (newer) iTunesDB\n";
 exit(1);
}

return 0;
}
